#ifndef	ifmmediaH
#define	ifmmediaH

#include "spi_api.h"

#pragma pack(push)
#pragma pack(1) //\̂̃oE1oCgɂ pragma
//SoCgPʂň
typedef struct{
  unsigned int   uk1;
  unsigned int   uk2;
  unsigned int   uk3;
  unsigned int   uk4;
} UNKNOWN_FILE;
#pragma pack(pop)

//t@C`FbNɍŒKvȃTCY
#define HEAD_BUFF 32
//WAVE
#define RIFF_TYPE_ID    0x46464952 /* "RIFF" */
#define WAVE_TYPE_ID    0x45564157 /* "WAVE" */
//AIFF
#define FORM_TYPE_ID    0x4d524f46 /* "FORM" */
#define AIFF_TYPE_ID    0x46464941 /* "AIFF" */
#define COMM_TYPE_ID    0x4d4d4f43 /* "COMM" */
//MIDI
#define MTHD_TYPE_ID    0x6468544d /* "MThd" */
#define MIDI_H_SIZE     0x06000000 /* 00 00 00 06 */
#define MTRK_TYPE_ID    0x6b72544d /* "MTrk" */
#define RMID_TYPE_ID    0x44494d52 /* "RMID" */
#define MIDS_TYPE_ID    0x5344494d /* "MIDS" */
//AVI
#define AVI_TYPE_ID     0x20495641 /* "AVI " */
//MOV
#define MDAT_TYPE_ID    0x7461646d /* "mdat" */
#define MOOV_TYPE_ID    0x766f6f6d /* "moov" */
//MPEG
#define MPEG_A_TYPE_ID  0xba010000 /* 00 00 01 BA */
#define MPEG_B_TYPE_ID  0xb3010000 /* 00 00 01 B3 */
#define CDXA_TYPE_ID    0x41584443 /* "CDXA" */
#define FMT_TYPE_ID     0x20746D66 /* "fmt " */
#define XA_TYPE_ID      0x41581131 /* 31 11 "XA" */
//MP3
#define MPA_TYPE_ID     0x0000f0ff /* 12bit܂1 */
#define ID3TAG_ID       0x00334449 /* "ID3" */
#define RMP3_TYPE_ID    0x33504d52 /* "RMP3" */
//AU
#define SND_TYPE_ID     0x646e732e /* ".snd" */
//WMA
//WMV
//ʕ@Ȃ
//OGG
#define OGG_TYPE_ID     0x5367674f /* "OggS" */

//t@C^Cv
#define FT_DEBUG    (0x40000000 +0x80000000 )
#define FT_UNKNOWN  0x00000000
#define FT_WAVE     1
#define FT_AIFF     2
#define FT_MIDI     3
#define FT_AVI      (4 +0x80000000 )
#define FT_MOV      (5 +0x80000000 )
#define FT_MPEG     (6 +0x80000000 )
#define FT_MPA      7
#define FT_AU       8
#define FT_WMA      9
#define FT_WMV      (10 +0x80000000 )
#define FT_ASF      (11 +0x80000000 )
#define FT_OGG      12
#define FT_COUNT    12
//͂Ȋ
#define IS_MOVIE(ft) (((ft) & 0x80000000)? true: false)

//TCY{
#define MS_X1 0 //P{
#define MS_X2 1 //Q{
#define MS_X4 2 //S{
#define MS_CS 3 //JX^TCY
#define MS_FL 4 //tXN[

void  __fastcall LoadOptions(void);
void __fastcall GetSusieCompatiAppName(TStringList* AppSL);
unsigned int __fastcall GetFileType(const char *data, const char *filename);
HICON __fastcall GetIconHandle(const unsigned int filetype, unsigned int flag);
bool  __fastcall GetFileIcon(HANDLE *pHBInfo, HANDLE *pHBm, const unsigned int filetype);
bool  __fastcall PutTempFile(char *tempfname, const char *buf, const long len);
bool __fastcall to24bit(const char *dibimg, HANDLE *pHBInfo, HANDLE *pHBm);
bool __fastcall BWcheck(HANDLE *pHBInfo, HANDLE *pHBm);
bool  __fastcall GetMovieFrame(const char *filename, HANDLE *pHBInfo, HANDLE *pHBm);
int   __fastcall MediaPlay(const char *filename, const bool inmem, const unsigned int filetype,
                   const SPI_PROGRESS lpPrgressCallback, const long lData);

#endif //ifmmediaH

